<script setup lang="ts">
import type { Employee } from '@/types/Employee'
import { ref, onMounted } from 'vue'
import { useRouter } from 'vue-router'

const router = useRouter() // ใช้ useRouter ในการทำงานกับ Vue Router
const errorText = ref<string>('')

const showPassword = ref(false)
const username = ref('')
const password = ref('')

const usernameRules = ref([
  (v: string) => !!v || 'Username is required',
  (v: string) => (v && v.length <= 20) || 'Username must be less than 20 characters'
])

const passwordRules = ref([
  (v: string) => !!v || 'Password is required',
  (v: string) => (v && v.length <= 20) || 'Password must be less than 20 characters'
])

const employees = ref<Employee[]>([]) // ประกาศตัวแปร employees ที่นี่

function initialize() {
  employees.value = [
    {
      id: 1,
      name: 'manager',
      email: 'managerMail',
      tel: '0987654321',
      password: 'pass@word123',
      gender: 'female',
      roles: ['manager', 'staff']
    },
    {
      id: 2,
      name: 'kanoknapas',
      email: 'managerMail2',
      tel: '0987653466',
      password: 'pass@word123',
      gender: 'male',
      roles: ['manager', 'staff']
    },
    {
      id: 3,
      name: 'staff',
      email: 'staffMail',
      tel: '0987634876',
      password: 'pass@word123',
      gender: 'female',
      roles: ['staff']
    },
    {
      id: 4,
      name: 'top',
      email: 'staffMail2',
      tel: '0987947455',
      password: 'pass@word123',
      gender: 'male',
      roles: ['staff']
    },
    {
      id: 5,
      name: 'staff3',
      email: 'staffMail3',
      tel: '0987653466',
      password: 'pass@word123',
      gender: 'female',
      roles: ['staff']
    },
    {
      id: 6,
      name: 'Chanon114',
      email: 'Chanonthananan2028@gmail.com',
      tel: '0830637986',
      password: '12345',
      gender: 'male',
      roles: ['staff']
    }
  ]
}

let loginUser = null

function validateCredentials() {
  const employee = employees.value.find(
    (emp) => emp.name === username.value && emp.password === password.value
  )
  return !!employee
}

function submit() {
  errorText.value = '' // รีเซ็ตข้อความผิดพลาด

  if (!username.value.trim() || !password.value.trim()) {
    errorText.value = 'Username or password cannot be empty!'
    return
  }
  if (!validateCredentials()) {
    errorText.value = 'Username or password incorrect!'
    return
  }

  // หาข้อมูลของผู้ใช้ที่ล็อกอินเข้าระบบ
  loginUser = employees.value.find(
    (emp) => emp.name === username.value && emp.password === password.value
  )

  // แสดงข้อมูลใน console.log
  console.log('Credentials are valid!')
  console.log('LoginUser:', loginUser)
  router.push({ name: 'mainmenu' })
}

onMounted(() => {
  initialize() // เรียกใช้ฟังก์ชัน initialize เมื่อ component ถูก mount
  console.log(employees.value) // แสดงข้อมูลใน employees เมื่อ component ถูก mount
})
</script>
<template>
  <v-parallax
    height="auto"
    src="./img/_9011db4a-dc74-46c4-8507-1cbb55fb34f8.jpg"
    overflow-y="hidden"
  >
    <v-card width="400" height="450" style="margin: auto; margin-top: 10%">
      <v-sheet width="300" height="280" class="mx-auto" style="margin: 15%">
        <v-form fast-fail @submit.prevent style="padding: 3%">
          <v-text-field v-model="username" label="Username" :rules="usernameRules"></v-text-field>
          <v-text-field
            v-model="password"
            label="Password"
            :rules="passwordRules"
            :type="showPassword ? 'text' : 'password'"
          ></v-text-field>

          <v-checkbox label="Show password?" v-model="showPassword"></v-checkbox>
          <div v-if="errorText" style="color: red">{{ errorText }}</div>
        </v-form>
      </v-sheet>
      <v-btn
        type="submit"
        block
        class="mt-2"
        height="50"
        style="background-color: rgb(0, 212, 250)"
        @click="submit()"
      >
        <h4>Submit</h4>
      </v-btn>
    </v-card></v-parallax
  >
</template>
